
#include "class_creator.h"

int EntityVtableOffset;

KTrie<VirtualTable*> ClassnameMap;

VirtualTable* create_virtual_table( char* classname_new, char* classname_original )
{
	edict_t *entity = CREATE_ENTITY();
	CALL_GAME_ENTITY( PLID, classname_original, &entity->v );

	if( !entity->pvPrivateData )
	{
		REMOVE_ENTITY( entity );
		return NULL;
	}

	VirtualTable* virtualTable = new VirtualTable( classname_new, classname_original );

	void** vtable = *( ( void*** )( ( ( char* )entity->pvPrivateData ) + EntityVtableOffset ) );

	void** new_vtable = virtualTable->get_vtable();

	memcpy( new_vtable,vtable,sizeof( void* ) * VirtualTableFunctionsNumber );

	REMOVE_ENTITY( entity );

	return virtualTable;
}


VirtualTable* currentVirtualTable = NULL;

RageHookReturn OnCallGameEntityPre( plid_t*& plid, const char*& entStr, entvars_t*& pev, qboolean& ret )
{
	currentVirtualTable = NULL;

	VirtualTable** virtualTable_ptr = ClassnameMap.retrieve( entStr );

	if( virtualTable_ptr )
	{
		currentVirtualTable = *virtualTable_ptr;

		entStr = currentVirtualTable->get_classname_original();
	}

	return RageHookIgnored;
}

RageHookReturn OnCallGameEntityPost( plid_t*& plid, const char*& entStr, entvars_t*& pev, qboolean& ret )
{
	if( ret && currentVirtualTable )
	{
		void*** vtable_address = ( ( void*** )( ( ( char* )Rage->entvar_to_edict( pev )->pvPrivateData )+ EntityVtableOffset ) );
		*vtable_address = currentVirtualTable->get_vtable();

		pev->classname = currentVirtualTable->get_classname_new_allocd();
	}

	return RageHookIgnored;
}

RageHookReturn OnCreateNamedEntityPre( int& n, edict_t*& e )
{
	currentVirtualTable = NULL;

	VirtualTable** virtualTable_ptr = ClassnameMap.retrieve( g_engfuncs.pfnSzFromIndex( n ) );

	if( virtualTable_ptr )
	{
		currentVirtualTable = *virtualTable_ptr;

		n = currentVirtualTable->get_classname_original_allocd();
	}

	return RageHookIgnored;
}

RageHookReturn OnCreateNamedEntityPost( int& n, edict_t*& e )
{
	if( e && currentVirtualTable )
	{
		void*** vtable_address = ( ( void*** )( ( ( char* )e->pvPrivateData ) + EntityVtableOffset ) );
		*vtable_address = currentVirtualTable->get_vtable();

		e->v.classname = currentVirtualTable->get_classname_new_allocd();
	}

	return RageHookIgnored;
}