
#include "module.h"
#include "sm_trie_tpl.h"
#include <math.h>

RageHookReturn OnCallGameEntityPre( plid_t*& plid, const char*& entStr, entvars_t*& pev, qboolean& ret );
RageHookReturn OnCallGameEntityPost( plid_t*& plid, const char*& entStr, entvars_t*& pev, qboolean& ret );
RageHookReturn OnCreateNamedEntityPre( int& n, edict_t*& e );
RageHookReturn OnCreateNamedEntityPost( int& n, edict_t*& e );

const int VirtualTableFunctionsNumber = 140;

class VirtualTable
{
	void* vtable[ VirtualTableFunctionsNumber ];
	char classname_new[ 100 ];
	char classname_original[ 100 ];

	public:

		VirtualTable( char* classname_new, char* classname_original )
		{
			strncpy( this->classname_new, classname_new,( sizeof( this->classname_new )/sizeof( char ) ) - sizeof( char ) );
			strncpy( this->classname_original, classname_original,( sizeof( this->classname_original ) / sizeof( char ) ) - sizeof(char ) );
		}

		void** get_vtable()
		{
			return vtable;
		}

		char* get_classname_original()
		{
			return this->classname_original;
		}

		char* get_classname_new()
		{
			return this->classname_new;
		}

		int get_classname_new_allocd()
		{
			return g_engfuncs.pfnAllocString( classname_new );
		}

		int get_classname_original_allocd()
		{
			return g_engfuncs.pfnAllocString( classname_original );
		}
};

extern VirtualTable* create_virtual_table( char* classname_new, char* classname_original );
extern int EntityVtableOffset;
extern KTrie<VirtualTable*> ClassnameMap;