
#include "module.h"

#define WEAPON_NOCLIP -1

// Base Weapon
//
#define WEAPON_AK47				28
#define AK47_PRIMARY_AMMO_ID	2
#define AK47_PRIMARY_MAX_AMMO	90
#define AK47_SECONDARY_AMMO_ID	-1
#define AK47_SECONDARY_MAX_AMMO	-1
#define AK47_POSITION			1
#define AK47_SLOT_ID			0
#define AK47_WEIGHT				25
#define AK47_FLAGS				0
#define AK47_WORLD_MODEL		"models/w_ak47.mdl"

// New weapon
//
#define WEAPON_HORNETGUN				WEAPON_AK47
#define HORNETGUN_PRIMARY_AMMO_ID		15
#define HORNETGUN_PRIMARY_MAX_AMMO		8
#define HORNETGUN_SECONDARY_AMMO_ID		-1
#define HORNETGUN_SECONDARY_MAX_AMMO	-1
#define HORNETGUN_SLOT_ID				AK47_SLOT_ID
#define HORNETGUN_POSITION				AK47_POSITION
#define HORNETGUN_WEIGHT				AK47_WEIGHT
#define HORNETGUN_FLAGS					ITEM_FLAG_NOAUTOSWITCHEMPTY | ITEM_FLAG_NOAUTORELOAD
#define HORNETGUN_WORLD_MODEL			"models/w_hgun.mdl"

#define HORNET_MAX_CARRY				HORNETGUN_PRIMARY_MAX_AMMO
#define HORNETGUN_DEFAULT_GIVE			HORNETGUN_PRIMARY_MAX_AMMO

// Hornet
//
#define HORNET_CLASSNAME		"Hornets"
#define HORNET_TYPE_RED			0
#define HORNET_TYPE_ORANGE		1
#define HORNET_RED_SPEED		( float )600
#define HORNET_ORANGE_SPEED		( float )800
#define	HORNET_BUZZ_VOLUME		( float )0.8
#define HORNET_FOV				( float )0.9


extern char base_weapon[];
extern char new_weapon[];

extern VirtualFunctionForModule* VFTakeDamage;
extern VirtualFunctionForModule* VFIRelationship;
extern VirtualFunctionForModule* VFSpawn;

#ifdef __linux__
	typedef void	( *FuncFallInit )					( void* );
	typedef int		( *FuncDefaultDeploy )				( void*, char*, char*, int, char*, int );
	typedef void	( *FuncSendWeaponAnim )				( void*, int, int );
	typedef Vector	( *FuncGetGunPosition )				( void* );
	typedef void	( *FuncResetSequenceInfo )			( void* );
	typedef float	( *FuncStudioFrameAdvance )			( void*, float );
	typedef int		( *OnTakeDamageType )				( void*, entvars_s*, entvars_s*, float, int );
	typedef void	( *FuncSetAnimation )				( void*, int );
	typedef void	( *FuncSUB_Remove )					( void* );
	typedef void	( *FuncSpawn )						( void* );
	typedef void	( *FuncDropPlayerItem )				( void*, char* );
	typedef void	( *FuncPrimaryAttack )				( void* );
	typedef void	( *FuncSecondaryAttack )			( void* );
	typedef void	( *FuncReload )						( void* );
#else
	typedef void	( _fastcall *FuncFallInit )			( void*, DUMMY );
	typedef int		( _fastcall *FuncDefaultDeploy )	( void*, DUMMY, char*, char*, int, char*, int );
	typedef void	( _fastcall *FuncSendWeaponAnim )	( void*, DUMMY, int, int );
	typedef Vector*	( _fastcall *FuncGetGunPosition )	( void*, DUMMY, Vector* );
	typedef void	( _fastcall *FuncResetSequenceInfo )( void*, DUMMY );
	typedef float	( _fastcall *FuncStudioFrameAdvance )( void*, DUMMY, float );
	typedef int		( _fastcall *OnTakeDamageType )		( void*, DUMMY, entvars_s*, entvars_s*, float, int );
	typedef void	( _fastcall *FuncSetAnimation )		( void*, DUMMY, int );
	typedef void	( _fastcall *FuncSUB_Remove )		( void*, DUMMY );
	typedef void	( _fastcall *FuncSpawn )			( void*, DUMMY );
	typedef void	( _fastcall *FuncDropPlayerItem )	( void*, DUMMY, char* );
#endif

typedef int ( *FuncGetAmmoIndex ) ( char* );
typedef void ( *FuncUTIL_PrecacheOtherWeapon ) ( char const* );

extern FuncFallInit FallInit;
extern FuncDefaultDeploy DefaultDeploy;
extern FuncSendWeaponAnim SendWeaponAnim;
extern FuncGetGunPosition GetGunPosition;
extern FuncResetSequenceInfo ResetSequenceInfo;
extern FuncStudioFrameAdvance StudioFrameAdvance;
extern FuncSetAnimation SetAnimation;
extern FuncSUB_Remove SUB_Remove;
extern FuncSpawn Spawn;
extern FuncDropPlayerItem DropPlayerItem;
extern FuncGetAmmoIndex GetAmmoIndex;
extern FuncUTIL_PrecacheOtherWeapon UTIL_PrecacheOtherWeapon;

#ifdef __linux__
	extern FuncPrimaryAttack OnPrimaryAttack;
	extern FuncSecondaryAttack OnSecondaryAttack;
	extern FuncReload OnReload;
#endif

extern int m_pfnThink_;
extern int m_pfnTouch_;
extern int m_pPlayer_;
extern int m_iId_;
extern int m_flNextPrimaryAttack_;
extern int m_flNextSecondaryAttack_;
extern int m_flTimeWeaponIdle_;
extern int m_iPrimaryAmmoType_;
extern int m_iSecondaryAmmoType_;
extern int m_iClip_;
extern int m_iClientClip_;
extern int m_iDefaultAmmo_;
extern int m_flNextAttack_;
extern int m_hEnemy_;
extern int m_flFieldOfView_;
extern int m_vecEnemyLKP_;
extern int m_iWeaponVolume_;
extern int m_iWeaponFlash_;
extern int m_afButtonPressed_;
extern int m_pActiveItem_;
extern int m_rgAmmo_;

extern int MsgIdWeaponList;
extern int MsgIdCurWeapon;

extern int OnHornetTracking;
extern int OnHornetDieTouch;