
#ifndef __WEAPON_UTIL_H__
#define __WEAPON_UTIL_H__

#include "amxxmodule.h"
#include "module.h"
#include "weapon_config.h"

entvars_t*	Create				( char* classname, Vector& vecOrigin, Vector& vecAngles, edict_t* pentOwner );
int			UTIL_EntitiesInBox	( void **pList, int listMax, const Vector &mins, const Vector &maxs, int flagMask );
BOOL		IsInViewCone		( entvars_t *pevHornet, entvars_t *pevEntity );
BOOL		FVisible			( entvars_t *pevHornet, entvars_t *pevEntity );
void*		BestVisibleEnemy	( void* pHornet, int distance );
Vector		UTIL_VecToAngles	( const Vector &vec );

#define ITEM_FLAG_SELECTONEMPTY		1
#define ITEM_FLAG_NOAUTORELOAD		2
#define ITEM_FLAG_NOAUTOSWITCHEMPTY	4
#define ITEM_FLAG_LIMITINWORLD		8
#define ITEM_FLAG_EXHAUSTIBLE		16

typedef struct
{
	int		iSlot;
	int		iPosition;
	const char	*pszAmmo1;	
	int		iMaxAmmo1;	
	const char	*pszAmmo2;	
	int		iMaxAmmo2;		
	const char	*pszName;
	int		iMaxClip;
	int		iId;
	int		iFlags;
	int		iWeight;
} ItemInfo;

#define LOUD_GUN_VOLUME			1000
#define NORMAL_GUN_VOLUME		600
#define QUIET_GUN_VOLUME		200

#define	BRIGHT_GUN_FLASH		512
#define NORMAL_GUN_FLASH		256
#define	DIM_GUN_FLASH			128

#define BIG_EXPLOSION_VOLUME	2048
#define NORMAL_EXPLOSION_VOLUME	1024
#define SMALL_EXPLOSION_VOLUME	512

#define CHAN_AUTO			0
#define CHAN_WEAPON			1
#define	CHAN_VOICE			2
#define CHAN_ITEM			3
#define	CHAN_BODY			4
#define CHAN_STREAM			5	
#define CHAN_STATIC			6

#define DMG_BULLET			(1 << 1)	// shot

#define R_AL	-2 // (ALLY) pals. Good alternative to R_NO when applicable.
#define R_FR	-1 // (FEAR)will run
#define	R_NO	0  // (NO RELATIONSHIP) disregard
#define R_DL	1  // (DISLIKE) will attack
#define R_HT	2  // (HATE)will attack this character instead of any visible DISLIKEd characters
#define R_NM	3  // (NEMESIS)  A monster Will ALWAYS attack its nemsis, no matter what

typedef enum
{
	PLAYER_IDLE,
	PLAYER_WALK,
	PLAYER_JUMP,
	PLAYER_SUPERJUMP,
	PLAYER_DIE,
	PLAYER_ATTACK1,

	// CS
	PLAYER_ATTACK1_RIGHT,
	PLAYER_SMALL_FLINCH,
	PLAYER_LARGE_FLINCH,
	PLAYER_RELOAD,
	PLAYER_HOLDBOMB
} PLAYER_ANIM;

inline edict_t *PrivateToEdict( const void *pdata )
{
	return Rage->index_to_entvar( Rage->private_to_index( pdata ) )->pContainingEntity;
};

inline entvars_t *PrivateToEntvars( const void *pdata )
{
	return Rage->index_to_entvar( Rage->private_to_index( pdata ) );
};

inline entvars_t* EdictToEntvar( edict_t * e )
{
	return &( e->v );
}

inline void set_pdata_float( edict_t* e, int offset, float newValue )
{
	*( ( float* )e->pvPrivateData + offset ) = newValue;
}

inline void set_pdata_int( edict_t* e, int offset, int newValue )
{
	*( ( int* )e->pvPrivateData + offset ) = newValue;
}

inline float get_pdata_float( edict_t* e, int offset )
{
	return *( ( float* )e->pvPrivateData + offset );
}

inline int get_pdata_int( edict_t* e, int offset )
{
	return *( ( int* )e->pvPrivateData + offset );
}

inline void* get_pdata_cbase( edict_t* e, int offset )
{
	return *( ( void** )( ( int* )e->pvPrivateData + offset ) );
}

inline void SetTouch_( edict_t* e, void* funcAddress )
{
	#ifdef __linux__
		*( ( long* )e->pvPrivateData + m_pfnTouch_ ) = funcAddress == NULL ? NULL : 0xFFFF0000;
		*( ( long* )e->pvPrivateData + m_pfnTouch_ + 1 ) = ( long )( funcAddress );
	#else
		*( ( long* )e->pvPrivateData + m_pfnTouch_ ) = ( long )( funcAddress );
	#endif
}

inline void SetThink_( edict_t* e, void* funcAddress )
{
	#ifdef __linux__
		*( ( long* )e->pvPrivateData + m_pfnThink_ ) = funcAddress == NULL ? NULL : 0xFFFF0000;
		*( ( long* )e->pvPrivateData + m_pfnThink_ + 1 ) = ( long )( funcAddress );
	#else
		*( ( long* )e->pvPrivateData + m_pfnThink_ ) = ( long )( funcAddress );
	#endif
}

#endif // __WEAPON_UTIL_H__