
#include "module_api.h"
#include "weapon/hornetgun.h"

void OnLoadFunction( FunctionForModule* function )
{
	if( !strcmp( function->get_name(), "CBasePlayerItem::FallInit" ) )
	{
		FallInit = ( FuncFallInit )function->get_managed_address();
	}
	else if( !strcmp( function->get_name(), "CBasePlayerWeapon::DefaultDeploy" ) )
	{
		DefaultDeploy = ( FuncDefaultDeploy )function->get_managed_address();
	}
	else if( !strcmp( function->get_name(), "CBaseAnimating::ResetSequenceInfo" ) )
	{
		//ResetSequenceInfo = ( FuncResetSequenceInfo )function->get_managed_address();
	}
	else if( !strcmp( function->get_name(), "CBaseAnimating::StudioFrameAdvance" ) )
	{
		//StudioFrameAdvance = ( FuncStudioFrameAdvance )function->get_managed_address();
	}
	else if( !strcmp( function->get_name(), "CBasePlayer::SetAnimation" ) )
	{
		SetAnimation = ( FuncSetAnimation )function->get_managed_address();
	}
	else if( !strcmp( function->get_name(), "CBasePlayer::DropPlayerItem" ) )
	{
		DropPlayerItem = ( FuncDropPlayerItem )function->get_managed_address();
		function->add_module_hook( ( void* )&OnDropPlayerItem, RageHookPre );
	}
	else if( !strcmp( function->get_name(), "CBasePlayer::GetAmmoIndex" ) )
	{
		GetAmmoIndex = ( FuncGetAmmoIndex )function->get_managed_address();
		function->add_module_hook( ( void* )&OnGetAmmoIndex, RageHookPost );
	}
	else if( !strcmp( function->get_name(), "CBaseEntity::SUB_Remove" ) )
	{
		SUB_Remove = ( FuncSUB_Remove )function->get_managed_address();
	}
	else if( !strcmp( function->get_name(), "UTIL_PrecacheOtherWeapon" ) )
	{
		UTIL_PrecacheOtherWeapon = ( FuncUTIL_PrecacheOtherWeapon )function->get_managed_address();
	}
	else if( !strcmp( function->get_name(), "CreateNamedEntity" ) )
	{
		function->add_module_hook( ( void* )&OnCreateNamedEntityPre, RageHookPre );
		function->add_module_hook( ( void* )&OnCreateNamedEntityPost, RageHookPost );
	}
	else if( !strcmp( function->get_name(), "CallGameEntity" ) )
	{
		function->add_module_hook( ( void* )&OnCallGameEntityPre, RageHookPre );
		function->add_module_hook( ( void* )&OnCallGameEntityPost, RageHookPost );
	}
}	

static bool Attached = false;

void OnAmxxAttach()
{
	//Rage->write_to_file_ln( "debug.txt", "OnAmxxAttach - START" );

	if( Attached )
		return;
	else 
		Attached = true;

	EntityVtableOffset = Rage->get_vtable_offset( "CBaseEntity" );

	if( EntityVtableOffset == -1 )
	{
		Rage->add_error( "Failed to retrieve vtable offset for CBaseEntity" );
		return;
	}

	VirtualTable* virtual_table = create_virtual_table( new_weapon, base_weapon );

	ClassnameMap.insert( virtual_table->get_classname_new(), virtual_table );

	void **vtable = virtual_table->get_vtable();

	#ifdef __linux_
		int spawn_offset = 2;
		int precache_offset = 3;
		int getitemoinfo_offset = 63;
		int deploy_offset = 66;
		int holster_offset = 69;
		int primaryattack_offset = 89;
		int secondaryattack_offset = 90;
		int reload_offset = 91;
		int weaponidle_offset = 92;
	#else
		int spawn_offset = 0;
		int precache_offset = 1;
		int getitemoinfo_offset = 61;
		int deploy_offset = 64;
		int holster_offset = 67;
		int primaryattack_offset = 87;
		int secondaryattack_offset = 88;
		int reload_offset = 89;
		int weaponidle_offset = 90;
	#endif	

	VirtualFunctionForModule* vf = NULL;

	vf = Rage->get_virtual_function( "SendWeaponAnim" );
	SendWeaponAnim = ( FuncSendWeaponAnim )vf->create_with_class( new_weapon )->get_managed_address();

	vf = Rage->get_virtual_function( "GetGunPosition" );
	GetGunPosition = ( FuncGetGunPosition )vf->create_with_class( "player" )->get_managed_address();

	vf = Rage->get_virtual_function( "PreThink" );
	vf->create_with_class( "player" )->add_module_hook( ( void* )&PreThink, RageHookPre );

	vf = Rage->get_virtual_function( "Killed" );
	vf->create_with_class( "player" )->add_module_hook( ( void* )&Killed, RageHookPre );

	VFSpawn = Rage->get_virtual_function( "Spawn" );
	VFSpawn->create_with_class( "info_target" )->add_module_hook( ( void* )&HornetSpawn, RageHookPost );

	vf = Rage->get_virtual_function( "AddToPlayer" );
	vf->create_with_class( new_weapon )->add_module_hook( ( void* )&New_AddToPlayer_Post, RageHookPost );
	vf->create_with_class( base_weapon )->add_module_hook( ( void* )&Base_AddToPlayer_Post, RageHookPost );

	vf = Rage->get_virtual_function( "AddPlayerItem" );
	vf->create_with_class( "player" )->add_module_hook( ( void* )&AddPlayerItem_Pre, RageHookPre );

	VFTakeDamage = Rage->get_virtual_function( "TakeDamage" );
	VFTakeDamage->create_with_class( "info_target" )->add_module_hook( ( void* )&OnTakeDamage, RageHookPre );

	//Rage->write_to_file_ln( "debug.txt", "\tOnAmxxAttach - 1" );

	#ifdef __linux__
		// For some reason, setting new addresses in the vtable doesn't work in linux..
		vf = Rage->get_virtual_function( "Spawn" );
		vf->create_with_class( new_weapon )->add_module_hook( ( void* )&FirstSpawn, RageHookPre );

		//Rage->write_to_file_ln( "debug.txt", "\tOnAmxxAttach - 2" );

		vf = Rage->get_virtual_function( "Precache" );
		vf->create_with_class( new_weapon )->add_module_hook( ( void* )&Precache, RageHookPre );

		//Rage->write_to_file_ln( "debug.txt", "\tOnAmxxAttach - 3" );

		vf = Rage->get_virtual_function( "GetItemInfo" );
		vf->create_with_class( new_weapon )->add_module_hook( ( void* )&GetItemInfo, RageHookPre );

		//Rage->write_to_file_ln( "debug.txt", "\tOnAmxxAttach - 4" );

		vf = Rage->get_virtual_function( "Deploy" );
		vf->create_with_class( new_weapon )->add_module_hook( ( void* )&OnDeploy, RageHookPre );

		//Rage->write_to_file_ln( "debug.txt", "\tOnAmxxAttach - 5" );

		vf = Rage->get_virtual_function( "Holster" );
		vf->create_with_class( new_weapon )->add_module_hook( ( void* )&Holster, RageHookPre );

		//Rage->write_to_file_ln( "debug.txt", "\tOnAmxxAttach - 6" );

		vf = Rage->get_virtual_function( "PrimaryAttack" );
		vf->create_with_class( new_weapon )->add_module_hook( ( void* )&PrimaryAttack, RageHookPre );
		OnPrimaryAttack = ( FuncPrimaryAttack )vf->create_with_class( new_weapon )->get_managed_address();

		//Rage->write_to_file_ln( "debug.txt", "\tOnAmxxAttach - 7" );

		vf = Rage->get_virtual_function( "SecondaryAttack" );
		vf->create_with_class( new_weapon )->add_module_hook( ( void* )&SecondaryAttack, RageHookPre );
		OnSecondaryAttack = ( FuncSecondaryAttack  )vf->create_with_class( new_weapon )->get_managed_address();

		//Rage->write_to_file_ln( "debug.txt", "\tOnAmxxAttach - 8" );

		vf = Rage->get_virtual_function( "Reload" );
		vf->create_with_class( new_weapon )->add_module_hook( ( void* )&Reload, RageHookPre );
		OnReload = ( FuncReload )vf->create_with_class( new_weapon )->get_managed_address();

		//Rage->write_to_file_ln( "debug.txt", "\tOnAmxxAttach - 9" );

		vf = Rage->get_virtual_function( "WeaponIdle" );
		vf->create_with_class( new_weapon )->add_module_hook( ( void* )&WeaponIdle, RageHookPre );
	#else
		vtable[ spawn_offset			] = (void*)&FirstSpawn;
		vtable[ precache_offset			] = (void*)&Precache;
		vtable[ getitemoinfo_offset		] = (void*)&GetItemInfo;
		vtable[ deploy_offset			] = (void*)&OnDeploy;
		vtable[ holster_offset			] = (void*)&Holster;
		vtable[ primaryattack_offset	] = (void*)&PrimaryAttack;
		vtable[ secondaryattack_offset	] = (void*)&SecondaryAttack;
		vtable[ reload_offset			] = (void*)&Reload;
		vtable[ weaponidle_offset		] = (void*)&WeaponIdle;
	#endif

	//Rage->write_to_file_ln( "debug.txt", "OnAmxxAttach - END" );
}

void OnPluginsLoaded()
{
	//Rage->write_to_file_ln( "debug.txt", "OnPluginsLoaded - START" );

	UTIL_PrecacheOtherWeapon( new_weapon );

	OnHornetTracking = MF_RegisterForward( "OnHornetTracking", ET_STOP, FP_CELL, FP_CELL, FP_CELL, FP_DONE );
	OnHornetDieTouch = MF_RegisterForward( "OnHornetDieTouch", ET_STOP, FP_CELL, FP_CELL, FP_CELL, FP_DONE );

	//Rage->write_to_file_ln( "debug.txt", "OnPluginsLoaded - END" );
}

int RegUserMsg_Post( const char *ccName, int ) 
{ 
	if( !strcmp( ccName, "WeaponList" ) ) 
	{
		MsgIdWeaponList = META_RESULT_ORIG_RET( int );
	}
	else if( !strcmp( ccName, "CurWeapon" ) ) 
	{
		MsgIdCurWeapon = META_RESULT_ORIG_RET( int );
	}

	RETURN_META_VALUE( MRES_IGNORED, 0 );
} 

void OnLoadVirtualFunction( VirtualFunctionForModule* virtual_function )
{

}

void OnLoadFunctionIncomplete( FunctionIncompleteForModule* function_incomplete )
{

}

void OnLoadLibrary(LibraryForModule* library)
{

}