
#include "weapon/hornetgun.h"
#include "weapon/projectile/hornet.h"
 

void IgniteTrail( void* pHornet )
{
	//Rage->write_to_file_ln( "debug.txt", "IgniteTrail - START" );

	int			hornetIndex	= Rage->private_to_index( pHornet );
	entvars_t*	pevHornet	= Rage->index_to_entvar( hornetIndex );

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
		WRITE_BYTE( TE_BEAMFOLLOW );
		WRITE_SHORT( hornetIndex );	// entity
		WRITE_SHORT( HornetTrail );	// model
		WRITE_BYTE( 10 );			// life
		WRITE_BYTE( 2 );			// width
		
		switch( m_iHornetType )
		{
			case HORNET_TYPE_RED:
				WRITE_BYTE( 179 );
				WRITE_BYTE( 39 );   
				WRITE_BYTE( 14 );  
				break;
			case HORNET_TYPE_ORANGE:
				WRITE_BYTE( 255 );  
				WRITE_BYTE( 128 );  
				WRITE_BYTE( 0 );  
				break;
		}

		WRITE_BYTE( 128 );	// brightness
	MESSAGE_END();

	//Rage->write_to_file_ln( "debug.txt", "IgniteTrail - END" );
}


#ifdef __linux__
	void OnSUB_Remove( void* pHornet )
#else
	void _fastcall OnSUB_Remove( void* pHornet, DUMMY )
#endif
	{
		//Rage->write_to_file_ln( "debug.txt", "OnSUB_Remove - START" );

		#ifdef __linux__
			SUB_Remove( pHornet );
		#else 
			SUB_Remove( pHornet, DUMMY_VAL );
		#endif

		//Rage->write_to_file_ln( "debug.txt", "OnSUB_Remove - END" );
	}


#ifdef __linux__
	void TrackTarget( void* pHornet )
#else
	void _fastcall TrackTarget( void* pHornet, DUMMY )
#endif
	{
		//Rage->write_to_file_ln( "debug.txt", "TrackTarget - START" );

		entvars_t*	pevHornet	= PrivateToEntvars( pHornet );
		edict_t*	pentHornet	= ENT( pevHornet );

		Vector	vecFlightDir;
		Vector	vecDirToEnemy;
		Vector	vecEnemyLKP;
		float	flDelta;

		#ifdef __linux__
			//StudioFrameAdvance( pHornet, 0.0 );
		#else 
			//StudioFrameAdvance( pHornet, DUMMY_VAL, 0.0 );
		#endif

		if( gpGlobals->time > m_flStopAttack )
		{
			//Rage->write_to_file_ln( "debug.txt", "\tTrackTarget - Time to die 1" );

			SetTouch_( pentHornet, NULL );
			SetThink_( pentHornet, ( void* )&OnSUB_Remove );

			//Rage->write_to_file_ln( "debug.txt", "\tTrackTarget - Time to die 2" );

			pevHornet->nextthink = gpGlobals->time + 0.1;
			return;
		}

		void* pEnemy = NULL;

		if( !m_iEnemy )
		{
			pEnemy = BestVisibleEnemy( pHornet, 512 );
			m_iEnemy = pEnemy ? Rage->private_to_index( pEnemy ) : 0;
		}

		pEnemy = m_iEnemy ? Rage->index_to_private( m_iEnemy ) : NULL;

		if( pEnemy != NULL )
		{
			entvars_t* pevEnemy = Rage->index_to_entvar( m_iEnemy );

			if( FVisible( pevHornet, pevEnemy ) )
			{
				pevHornet->oldorigin = ( pevEnemy->absmax + pevEnemy->absmin ) * 0.5;
			}
			else
			{
				m_iEnemy = 0;
				pevHornet->oldorigin = pevHornet->oldorigin + pevHornet->velocity * m_flFlySpeed * 0.1;
			}
		}
		else
		{
			pevHornet->oldorigin = pevHornet->oldorigin + pevHornet->velocity * m_flFlySpeed * 0.1;
		}

		vecDirToEnemy = ( pevHornet->oldorigin - pevHornet->origin ).Normalize();

		if( pevHornet->velocity.Length() < 0.1 )
			vecFlightDir = vecDirToEnemy;
		else 
			vecFlightDir = pevHornet->velocity.Normalize();

		flDelta = DotProduct( vecFlightDir, vecDirToEnemy );

		if( flDelta < 0.5 )
		{
			switch( RANDOM_LONG( 0, 2 ) )
			{
				case 0:	EMIT_SOUND_DYN2( pentHornet, CHAN_VOICE, "hornet/ag_buzz1.wav", HORNET_BUZZ_VOLUME, ATTN_NORM, 0, 100 );	break;
				case 1:	EMIT_SOUND_DYN2( pentHornet, CHAN_VOICE, "hornet/ag_buzz2.wav", HORNET_BUZZ_VOLUME, ATTN_NORM, 0, 100 );	break;
				case 2:	EMIT_SOUND_DYN2( pentHornet, CHAN_VOICE, "hornet/ag_buzz3.wav", HORNET_BUZZ_VOLUME, ATTN_NORM, 0, 100 );	break;
			}
		}

		if( flDelta <= 0 && m_iHornetType == HORNET_TYPE_RED )
		{
			flDelta = 0.25;
		}

		pevHornet->velocity = ( vecFlightDir + vecDirToEnemy ).Normalize();

		if( pevHornet->owner && ( pevHornet->owner->v.flags & FL_MONSTER ) )
		{
			pevHornet->velocity.x += RANDOM_FLOAT( -0.10, 0.10 ); 
			pevHornet->velocity.y += RANDOM_FLOAT( -0.10, 0.10 );
			pevHornet->velocity.z += RANDOM_FLOAT( -0.10, 0.10 );
		}

		switch( m_iHornetType )
		{
			case HORNET_TYPE_RED:
				pevHornet->velocity = pevHornet->velocity * ( m_flFlySpeed * flDelta );
				pevHornet->nextthink = gpGlobals->time + RANDOM_FLOAT( 0.1, 0.3 );
				break;
			case HORNET_TYPE_ORANGE:
				pevHornet->velocity = pevHornet->velocity * m_flFlySpeed;
				pevHornet->nextthink = gpGlobals->time + 0.1;
				break;
		}

		pevHornet->angles = UTIL_VecToAngles( pevHornet->velocity );
		pevHornet->solid = SOLID_BBOX;

		/*if( pEnemy != NULL )
		{
			if( flDelta >= 0.4 && ( pevHornet->origin - pevHornet->oldorigin ).Length() <= 300 )
			{
				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pevHornet->origin );
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( pevHornet->origin.x );	// pos
					WRITE_COORD( pevHornet->origin.y );
					WRITE_COORD( pevHornet->origin.z );
					WRITE_SHORT( HornetPuff );		// model
					// WRITE_BYTE( 0 );				// life * 10
					WRITE_BYTE( 2 );				// size * 10
					WRITE_BYTE( 128 );			// brightness
				MESSAGE_END();

				switch( RANDOM_LONG( 0, 2 ) )
				{
					case 0:	EMIT_SOUND_DYN2( pentHornet, CHAN_VOICE, "hornet/ag_buzz1.wav", HORNET_BUZZ_VOLUME, ATTN_NORM, 0, 100 );	break;
					case 1:	EMIT_SOUND_DYN2( pentHornet, CHAN_VOICE, "hornet/ag_buzz2.wav", HORNET_BUZZ_VOLUME, ATTN_NORM, 0, 100 );	break;
					case 2:	EMIT_SOUND_DYN2( pentHornet, CHAN_VOICE, "hornet/ag_buzz3.wav", HORNET_BUZZ_VOLUME, ATTN_NORM, 0, 100 );	break;
				}

				pevHornet->velocity = pevHornet->velocity * 2;
				pevHornet->nextthink = gpGlobals->time + 1.0;

				m_flStopAttack = gpGlobals->time;
			}
		}*/

		//Rage->write_to_file_ln( "debug.txt", "TrackTarget - END" );
	}


#ifdef __linux__
	void DieTouch( void* pHornet, void *pOther )
#else
	void _fastcall DieTouch( void* pHornet, DUMMY, void *pOther )
#endif
	{
		//Rage->write_to_file_ln( "debug.txt", "DieTouch - START" );

		entvars_t*	pevHornet	= PrivateToEntvars( pHornet );
		edict_t*	pentHornet	= ENT( pevHornet );

		entvars_t*	pevOther	= PrivateToEntvars( pOther );
		edict_t*	pentOther	= ENT( pevOther );

		int ret = MF_ExecuteForward
		( 
			OnHornetDieTouch, 
			Rage->entvar_to_index( pevHornet ), 
			Rage->entvar_to_index( EdictToEntvar( pevHornet->owner ) ), 
			Rage->entvar_to_index( pevOther )
		);

		//Rage->write_to_file_ln( "debug.txt", "\tDieTouch - After MF_ExecuteForward" );

		if( !ret && pevOther && pevOther->takedamage )
		{
			switch( RANDOM_LONG( 0, 2 ) )
			{
				case 0 : EMIT_SOUND_DYN2( pentOther, CHAN_VOICE, "hornet/ag_hornethit1.wav", 1, ATTN_NORM, 0, 100 );	break;
				case 1 : EMIT_SOUND_DYN2( pentOther, CHAN_VOICE, "hornet/ag_hornethit2.wav", 1, ATTN_NORM, 0, 100 );	break;
				case 2 : EMIT_SOUND_DYN2( pentOther, CHAN_VOICE, "hornet/ag_hornethit3.wav", 1, ATTN_NORM, 0, 100 );	break;
			}

			//Rage->write_to_file_ln( "debug.txt", "\tDieTouch - Before OnTakeDamage" );

			OnTakeDamageType OnTakeDamage = ( OnTakeDamageType )VFTakeDamage->create_with_object( pOther )->get_managed_address();

			#ifdef __linux__
				OnTakeDamage( pOther, pevHornet, &( pevHornet->owner->v ), pevHornet->dmg, DMG_BULLET );
			#else
				OnTakeDamage( pOther, DUMMY_VAL, pevHornet, &( pevHornet->owner->v ), pevHornet->dmg, DMG_BULLET );
			#endif

			//Rage->write_to_file_ln( "debug.txt", "\tDieTouch - After OnTakeDamage" );
		}

		pevHornet->modelindex = 0;
		pevHornet->solid = SOLID_NOT;

		SetThink_( pentHornet, ( void* )&OnSUB_Remove );
		pevHornet->nextthink = gpGlobals->time + 1;

		//Rage->write_to_file_ln( "debug.txt", "DieTouch - END" );
	}


#ifdef __linux__
	void TrackTouch( void* pHornet, void *pOther )
#else
	void _fastcall TrackTouch( void* pHornet, DUMMY, void *pOther )
#endif
	{
		//Rage->write_to_file_ln( "debug.txt", "TrackTouch - START" );

		entvars_t*	pevHornet	= PrivateToEntvars( pHornet );
		edict_t*	pentHornet	= pevHornet->pContainingEntity;

		entvars_t*	pevOther	= PrivateToEntvars( pOther );
		edict_t*	pentOther	= pevOther->pContainingEntity;

		if( pentOther == pevHornet->owner || pevOther->modelindex == pevHornet->modelindex )
		{
			pevHornet->solid = SOLID_NOT;
			return;
		}

		if( !( pevOther->deadflag == DEAD_NO && pevOther->health > 0 ) )
		{
			pevHornet->velocity = pevHornet->velocity.Normalize();

			pevHornet->velocity.x *= -1;
			pevHornet->velocity.y *= -1;
			
			pevHornet->origin = pevHornet->origin + pevHornet->velocity * 4;
			pevHornet->velocity = pevHornet->velocity * m_flFlySpeed;

			return;
		}

		#ifdef __linux__
			DieTouch( pHornet, pOther );
		#else 
			DieTouch( pHornet, DUMMY_VAL, pOther );
		#endif

		//Rage->write_to_file_ln( "debug.txt", "TrackTouch - END" );
	}


#ifdef __linux__
	void StartTrack( void* pHornet )
#else
	void _fastcall StartTrack( void* pHornet, DUMMY )
#endif
	{
		//Rage->write_to_file_ln( "debug.txt", "StartTrack - START" );

		entvars_t*	pevHornet	= PrivateToEntvars( pHornet );
		edict_t*	pentHornet	= ENT( pevHornet );

		IgniteTrail( pHornet );

		SetTouch_( pentHornet, ( void* )&TrackTouch );
		SetThink_( pentHornet, ( void* )&TrackTarget );

		pevHornet->nextthink = gpGlobals->time + 0.1;

		//Rage->write_to_file_ln( "debug.txt", "StartTrack - END" );
	}


#ifdef __linux__
	void DartTouch( void* pHornet, void *pOther )
#else
	void _fastcall DartTouch( void* pHornet, DUMMY, void *pOther )
#endif
	{
		//Rage->write_to_file_ln( "debug.txt", "DartTouch - START" );

		#ifdef __linux__
			DieTouch( pHornet, pOther );
		#else
			DieTouch( pHornet, DUMMY_VAL, pOther );
		#endif

		//Rage->write_to_file_ln( "debug.txt", "DartTouch - END" );
	}

#ifdef __linux__
	void DarThink( void* pHornet )
#else
	void _fastcall DarThink( void* pHornet, DUMMY )
#endif
	{
		//Rage->write_to_file_ln( "debug.txt", "DarThink - START" );

		entvars_t*	pevHornet	= PrivateToEntvars( pHornet );
		edict_t*	pentHornet	= ENT( pevHornet );

		if( gpGlobals->time > m_flStopAttack )
		{
			SetTouch_( pentHornet, NULL );
			SetThink_( pentHornet, ( void* )&OnSUB_Remove );

			pevHornet->nextthink = gpGlobals->time + 0.1;
			return;
		}

		pevHornet->solid = SOLID_BBOX;
		pevHornet->nextthink = gpGlobals->time + 0.1;

		//Rage->write_to_file_ln( "debug.txt", "DarThink - END" );
	}


#ifdef __linux__
	void StartDart( void* pHornet )
#else
	void _fastcall StartDart( void* pHornet, DUMMY )
#endif
	{
		//Rage->write_to_file_ln( "debug.txt", "StartDart - START" );

		entvars_t*	pevHornet	= PrivateToEntvars( pHornet );
		edict_t*	pentHornet	= ENT( pevHornet );

		IgniteTrail( pHornet );

		SetTouch_( pentHornet, ( void* )&DartTouch );
		SetThink_( pentHornet, ( void* )&DarThink );

		m_flStopAttack = gpGlobals->time + 4.0;

		pevHornet->nextthink = gpGlobals->time;

		//Rage->write_to_file_ln( "debug.txt", "StartDart - END" );
	}


RageHookReturn HornetSpawn( void*& pHornet )
{
	entvars_t*	pevHornet	= PrivateToEntvars( pHornet );
	edict_t*	pentHornet	= ENT( pevHornet );

	if( pevHornet->iuser1 == 1337 )
	{
		//Rage->write_to_file_ln( "debug.txt", "HornetSpawn - START" );

		pevHornet->classname	= ALLOC_STRING( HORNET_CLASSNAME );
		pevHornet->movetype		= MOVETYPE_FLY;
		pevHornet->solid		= SOLID_BBOX;
		pevHornet->takedamage	= DAMAGE_YES;
		pevHornet->flags		|= FL_MONSTER;
		pevHornet->health		= 1;

		m_flStopAttack = gpGlobals->time + 3.5;

		if( RANDOM_LONG ( 1, 5 ) <= 2 )
		{
			m_iHornetType = HORNET_TYPE_RED;
			m_flFlySpeed = HORNET_RED_SPEED;
		}
		else
		{
			m_iHornetType = HORNET_TYPE_ORANGE;
			m_flFlySpeed = HORNET_ORANGE_SPEED;
		}

		SET_MODEL( pentHornet, "models/hornet.mdl" );
		SET_SIZE( pentHornet, Vector( -4, -4, -4 ), Vector( 4, 4, 4 ) );

		SetTouch_( pentHornet, ( void* )&DieTouch );
		SetThink_( pentHornet, ( void* )&StartTrack );

		pevHornet->dmg = 10;
		pevHornet->nextthink = gpGlobals->time + 0.1;

		#ifdef __linux__
			//ResetSequenceInfo( arg1 );
		#else 
			//ResetSequenceInfo( arg1, DUMMY_VAL );
		#endif

		pevHornet->animtime = gpGlobals->time;
		pevHornet->framerate = 1.0;

		//Rage->write_to_file_ln( "debug.txt", "HornetSpawn - END" );
	}

	return RageHookIgnored;
}

#define DMG_NEVERGIB	(1 << 12)
#define DMG_ALWAYSGIB	(1 << 13)

RageHookReturn OnTakeDamage( void*& pVictim, entvars_t*& pevInflictor, entvars_t*& pevAttacker, float& flDamage, int& bitsDamageType, int& ret )
{
	//Rage->write_to_file_ln( "debug.txt", "OnTakeDamage - START" );

	if( PrivateToEntvars( pVictim )->iuser1 == 1337 )
	{
		bitsDamageType &= ~ ( DMG_ALWAYSGIB );
		bitsDamageType |= DMG_NEVERGIB;
	}

	//Rage->write_to_file_ln( "debug.txt", "OnTakeDamage - END" );

	return RageHookIgnored;
}